﻿-- ////////////////
-- Commande SLASH
-- ////////////////
SLASH_ATA1 = '/ata';
local function AtaCommand(msg, editbox)
	listeHF = 0;
	if msg == 'clean' then CleanTrackList()
	elseif msg == 'check' then CheckBestRaid()
	elseif msg == 'help' or msg == '' then
		print("AtA commands :");
		print(L["ata config"]);
		print(L["ata raid lk"]);
		print(L["ata raid cata"]);
		print(L["ata check"]);
		print(L["ata clean"]);
		print(L["ata save"]);
		print(L["ata load"]);
		print(L["ata defaut"]);
	elseif msg == 'config' then
		AutoTrackerAchievement:Show();
		if AutoTrackerAchievementDB["Arena"] == true then AutoTrackerAchievement_CheckButton1:SetChecked(true); end
		if AutoTrackerAchievementDB["Raid"] == true then AutoTrackerAchievement_CheckButton2:SetChecked(true); end
		if AutoTrackerAchievementDB["Region"] == true then AutoTrackerAchievement_CheckButton3:SetChecked(true); end
		if AutoTrackerAchievementDB["Donjon"] == true then AutoTrackerAchievement_CheckButton4:SetChecked(true); end
		if AutoTrackerAchievementDB["defaut"] == true then AutoTrackerAchievement_CheckButton5:SetChecked(true); end
	elseif msg == 'reset' then AutoTrackerAchievementDB = AutoTrackerAchievementDB_Defaut;
	elseif msg == 'debug' then
		local name, realm = UnitName("player")
		if name == "Garikover" then
			if AutoTrackerAchievementDB["debug"] == true then
				AutoTrackerAchievementDB["debug"] = false
				print("Ata Debug mode : OFF");
				else
				AutoTrackerAchievementDB["debug"] = true
				print("Ata Debug mode : ON");
			end
		end
	elseif msg == 'info' then
		print("Zone :",GetCurrentMapAreaID());
	elseif string.find(msg, 'save ') == 1 then SaveTrackList(msg);
	elseif string.find(msg, 'load ') == 1 then LoadTrackList(msg);
	elseif string.find(msg, 'defaut ') == 1 then DefautTrackList(msg);
	elseif msg == 's' then SaveTrackQuests()
	elseif msg == 'l' then LoadTrackQuests()
	elseif msg == 'test' then
		for i,v in pairs(AutoTrackerAchievementDB) do
			if v ~= 0 then print(i,v)
				if i == "Favoris" then
				for i2,v2 in pairs(AutoTrackerAchievementDB["Favoris"]) do print("Favoris-" .. i2) end
				end			
			end
		end	
	elseif msg == 'get' then AtaMainFunction()
	else
		listeHF = RaidListe(msg);
		if listeHF ~= 0 then
		CleanTrackList()
		AchievListTable(listeHF)
		else
		print(L["Commande non reconnue"]);
		end
	end	
end
SlashCmdList["ATA"] = AtaCommand;

-- ////////////////
-- Variables
-- ////////////////
local AutoTrackerAchievementDB_Defaut = {
["Arena"] = true,
["Raid"] = true,
["Region"] = true,
["Donjon"] = true,
["defaut"] = true,
["defautliste"] = "",
["Favoris"] = {},
["debug"] = false,
["version"] = 4.2,
}

-- ////////////////
-- Fonctions XML
-- ////////////////
function Ata_CheckButton1_OnClick() -- Arena
if AutoTrackerAchievementDB["Arena"] == true then AutoTrackerAchievementDB["Arena"] = false
else AutoTrackerAchievementDB["Arena"] = true end
if AutoTrackerAchievementDB["debug"] == true then print("Arena",AutoTrackerAchievementDB["Arena"]); end
end
function Ata_CheckButton2_OnClick() -- Raid
if AutoTrackerAchievementDB["Raid"] == true then AutoTrackerAchievementDB["Raid"] = false
else AutoTrackerAchievementDB["Raid"] = true end
if AutoTrackerAchievementDB["debug"] == true then print("Raids",AutoTrackerAchievementDB["Raid"]); end
end
function Ata_CheckButton3_OnClick() -- Region
if AutoTrackerAchievementDB["Region"] == true then AutoTrackerAchievementDB["Region"] = false
else AutoTrackerAchievementDB["Region"] = true end
if AutoTrackerAchievementDB["debug"] == true then print("Region",AutoTrackerAchievementDB["Region"]); end
end
function Ata_CheckButton4_OnClick() -- Donjon
if AutoTrackerAchievementDB["Donjon"] == true then AutoTrackerAchievementDB["Donjon"] = false
else AutoTrackerAchievementDB["Donjon"] = true end
if AutoTrackerAchievementDB["debug"] == true then print("Donjon",AutoTrackerAchievementDB["Donjon"]); end
end
function Ata_CheckButton5_OnClick() -- défaut
if AutoTrackerAchievementDB["defaut"] == true then AutoTrackerAchievementDB["defaut"] = false
else AutoTrackerAchievementDB["defaut"] = true end
if AutoTrackerAchievementDB["debug"] == true then print("defaut",AutoTrackerAchievementDB["defaut"]); end
end
function Ata_Button1_OnClick()
AutoTrackerAchievement:Hide();
end
function Ata_Button2_OnClick()
if AutoTrackerAchievementDB["debug"] == true then print("Reset"); end
AutoTrackerAchievementDB = AutoTrackerAchievementDB_Defaut;
end
function Ata_Button3_OnClick()
	DefautTrackList(defautval:GetText());
end

-- ////////////////
-- Processus passif
-- ////////////////

local function eventHandler(self, event, ...)
	if event == "VARIABLES_LOADED" then
		if AutoTrackerAchievementDB == nil then
			print(L["Création de la sauvegarde"]);
			AutoTrackerAchievementDB = AutoTrackerAchievementDB_Defaut;
		elseif AutoTrackerAchievementDB["version"] == nil or AutoTrackerAchievementDB["version"] < AutoTrackerAchievementDB_Defaut["version"] then
			print(L["Mise à jour"]);
			-- sauvagarde des anciens paramètres
			AutoTrackerAchievementDB_Old = AutoTrackerAchievementDB
			-- ajustement des paramètres
			AutoTrackerAchievementDB = AutoTrackerAchievementDB_Defaut		
			-- insérer une restauration des données
			for i1,v1 in pairs(AutoTrackerAchievementDB) do
			if AutoTrackerAchievementDB_Old[i1] ~= nil then AutoTrackerAchievementDB[i1] = AutoTrackerAchievementDB_Old[i1] end
			end
		end
		AtaLocalisation(GetLocale())
	end
	
	if event == "ZONE_CHANGED_NEW_AREA" then AtaMainFunction(); end
	if event == "QUEST_ACCEPTED" and GetInstanceDifficulty() == 1 then CleanTrackList(); end
end

-- FONCTION DE CHARGEMENT
function AutoTrackerAchievement_OnLoad(self)
print("Achievement Tracker : OK");
self:RegisterEvent("ADDON_LOADED");
self:RegisterEvent("ZONE_CHANGED_NEW_AREA");
self:RegisterEvent("PLAYER_ENTERING_WORLD");
self:RegisterEvent("VARIABLES_LOADED");
self:RegisterEvent("QUEST_ACCEPTED");
self:SetScript("OnEvent", eventHandler);
end

-- FONCTIONS RECURRENTES
function CleanTrackList() 
	local achievlisted = {GetTrackedAchievements()};	
	for i=1,#achievlisted do
	RemoveTrackedAchievement(achievlisted[i])
	end
	if AutoTrackerAchievementDB["debug"] == true then print("Nettoyage liste"); end
end

function SaveTrackList(msg)
	local achievlisted = {GetTrackedAchievements()};	
	name = string.gsub(msg, "save ", "");
	if AutoTrackerAchievementDB["debug"] == true and name ~= "" then
	print("Sauvegarde : " .. name);
	AutoTrackerAchievementDB["Favoris"][name] = achievlisted;
	elseif name ~= "" then
	print(L["Liste sauvegardée"]);
	AutoTrackerAchievementDB["Favoris"][name] = achievlisted;
	else
	print(L["Nom de sauvegarde invalide"]);
	end
end

function LoadTrackList(msg)
	name = string.gsub(msg, "load ", "");
	if AutoTrackerAchievementDB["Favoris"][name] ~= nil then
	Liste = AutoTrackerAchievementDB["Favoris"][name];
	AchievListTable(Liste);
	else
	print(L["Pas de liste de ce nom"]);
	end
end

function DeleteTrackList(msg)
	name = string.gsub(msg, "delete ", "")
	AutoTrackerAchievementDB["Favoris"][name] = 0
	tableau = AutoTrackerAchievementDB["Favoris"]
	NewTab = {}
end

function DefautTrackList(msg)
	name = string.gsub(msg, "defaut ", "");
	if AutoTrackerAchievementDB["Favoris"][name] ~= nil then
	AutoTrackerAchievementDB["defautliste"] = name
	if AutoTrackerAchievementDB["debug"] == true then print("Defaut " .. name); end
	else
	print(L["Pas de liste de ce nom"]);
	end
end

-- Tracking des quetes
function SaveTrackQuests()
listequetes = {}
if GetNumQuestWatches() > 0 then
for i = 1,GetNumQuestWatches() do
questIndex = GetQuestIndexForWatch(1)
table.insert(listequetes, questIndex)
RemoveQuestWatch(questIndex)
if AutoTrackerAchievementDB["debug"] == true then print("Save " .. GetQuestLink(questIndex)); end
end
WatchFrame_Update()
end
end

function LoadTrackQuests()
if listequetes ~= nil then
for i=1, #listequetes do
AddQuestWatch(listequetes[i])
if AutoTrackerAchievementDB["debug"] == true then print("Load " .. GetQuestLink(listequetes[i])); end
end
WatchFrame_Update()
end
listequetes = {}
end

-- FONCTION PRINCIPALE
function AtaMainFunction()
	-- infos de base
	local nbtracked = 0
	if AutoTrackerAchievementDB["debug"] == true then print("Idzone = ",GetCurrentMapAreaID()); end
	CleanTrackList() -- on vire les HFs
	SaveTrackQuests() -- on vire les quêtes + sauvegarde
	IdZone = GetCurrentMapAreaID();
	
	-- Arene
	if CategorieListe(IdZone) ~= 0 and AutoTrackerAchievementDB["Arena"] then nbtracked = AchievListCat(CategorieListe(IdZone))
	-- Sombrelune
	elseif IdZone == 823 and AutoTrackerAchievementDB["Region"] then nbtracked = AchievListCat(CategorieListe(823))
	-- Bastonneurs
	elseif IdZone == 922 and AutoTrackerAchievementDB["Region"] and UnitLevel("player") > 89 then nbtracked = AchievListCat(CategorieListe(922))
	elseif IdZone == 925 and AutoTrackerAchievementDB["Region"] and UnitLevel("player") > 89 then nbtracked = AchievListCat(CategorieListe(925))
	-- Régions
	elseif RegionListe(IdZone) ~= 0 and AutoTrackerAchievementDB["Region"] then
		LoadTrackQuests()
		nbtracked = AchievListTable(RegionListe(IdZone))
	elseif DonjonListe(IdZone) ~= 0 and AutoTrackerAchievementDB["Donjon"] then
		nbtracked = AchievListTable(DonjonListe(IdZone))
	elseif RaidListe(IdZone) ~= 0 and AutoTrackerAchievementDB["Raid"] then
		nbtracked = AchievListTable(RaidListe(IdZone))
	elseif ScenarioListe(IdZone) ~= 0 and AutoTrackerAchievementDB["Donjon"] then
		nbtracked = AchievListTable(ScenarioListe(IdZone))
	-- Zone non gérer
	else
		if AutoTrackerAchievementDB["debug"] then print(L["Zone sans Haut-faits"]); end
		LoadTrackQuests()
	end
	
	-- Debug si aucun HF et dans un scénario
	if nbtracked == 0 and GetInstanceDifficulty() ~= 1 and AutoTrackerAchievementDB["debug"] == true then
	print("----------------");
	print("Diff = ",GetInstanceDifficulty());
	print("Idzone = ",GetCurrentMapAreaID());
	print("----------------");
	end
	
	-- Défaut si aucun quetes en suivi
	if AutoTrackerAchievementDB["defaut"] == true and AutoTrackerAchievementDB["defautliste"] ~= 0 and GetInstanceDifficulty() == 1 and GetNumQuestWatches() == 0 then
	if nbtracked == nil or nbtracked == 0 then LoadTrackList(AutoTrackerAchievementDB["defautliste"]) end
	end
	
	-- DEBUG
	if AutoTrackerAchievementDB["debug"] == true then
	print("Diff = ",GetInstanceDifficulty());
	print("NbTrack = ",nbtracked);
	print("NbQuestsW = ",GetNumQuestWatches());
	end
end

-- Fonction qui renvoie l'id du HF en fonction de la zone (pour les HF de quete)
function RegionListe(IdZone)
local Neutral = {
	[16] = {4896,},  -- Arathi Highlands
	[17] = {4900,5444,},  -- Badlands
	[475] = {1193,1276,},  -- Blade's Edge Mountains
	[19] = {4909,},  -- Blasted Lands
	[29] = {4901,},  -- Burning Steppes
	[640] = {4871,5445,5450,5446,5447,5449,},  -- Deepholm
	[101] = {4930,},  -- Desolace
	[23] = {4892,},  -- Eastern Plaguelands
	[182] = {4931,},  -- Felwood
	[492] = {40,},    -- Icecrown
	[606] = {4870,5869,4959,5864,5868,5861,5483,5865,5862,5860,},  -- Mount Hyjal
	[479] = {1194,},  -- Netherstorm
	[37] = {4906,},  -- Northern Stranglethorn
	[28] = {4910,},  -- Searing Gorge
	[473] = {1195,},  -- Shadowmoon Valley
	[493] = {39,938,},	-- Sholazar Basin
	[261] = {4934,},  -- Silithus
	[38] = {4904,},  -- Swamp of Sorrows
	[161] = {4935,},  -- Tanaris
	[673] = {4905,},  -- The Cape of Stranglethorn
	[26] = {4897,},  -- The Hinterlands
	[495] = {38,1428,},    -- The Storm Peaks
	[61] = {4938,},  -- Thousand Needles
	[720] = {4872,4961,5317,},  -- Uldum
	[201] = {4939,},  -- Un'Goro Crater
	[22] = {4893,},  -- Western Plaguelands
	[281] = {4940,5443,},  -- Winterspring
	[467] = {1190,},  -- Zangarmarsh
	[496] = {36,1596,},    -- Zul'Drak
	[181]  = {5454,5547,5448,5546,},	-- Azshara
	[42] = {5453,}, -- Sombrivage
	[478] = {1275,}, -- Terokkar
	[477] = {939,}, -- Nagrand
	-- CATACLYSM
	[488] = {1277,547,}, -- Désolation des dragons
	[486] = {561,}, -- Toundra
	[613] = {4975,5452,}, -- Vashj'ir
	[700] = {5451,4960,}, -- Hautes terres du Crépuscule
	[795] = {5870,5872,5874,5859,5866,5871,5867,}, -- Front du magma
	-- PANDARIE
	[809] = {6537,7286,},  -- Kun-Lai Summit
	[858] = {6540,7316,7312,7313,},  -- Dread Wastes
	[810] = {6539,7297,7298,7288,7299,},  -- Townlong Steppes
	[811] = {7315,7319,7320,},  -- Vale of Eternal Blossoms
	[807] = {6301,7295,},  -- Valley of the Four Winds
	-- 5.2
	[928] = {8099,8104,8108,8111,8114,8116,8118,8120,8101,8105,8107,8110,8112,8115,8117,8119,8212}, -- L’île du Tonnerre
	[2] = {8123,}, -- L'ile des géants
}

local Alliance = {
	[43]  = {4925,},  -- Ashenvale
	[476] = {4926,},  -- Bloodmyst Isle
	[486] = {33,},    -- Borean Tundra
	[42]  = {4928,},  -- Darkshore
	[488] = {35,},    -- Dragonblight
	[34]  = {4903,},  -- Duskwood
	[141] = {4929,},  -- Dustwallow Marsh
	[121] = {4932,},  -- Feralas
	[490] = {37,},    -- Grizzly Hills
	[465] = {1189,},  -- Hellfire Peninsula
	[491] = {34,},    -- Howling Fjord
	[35]  = {4899,},  -- Loch Modan
	[477] = {1192,},  -- Nagrand
	[36]  = {4902,},  -- Redridge Mountains
	[607] = {4937,},  -- Southern Barrens
	[81]  = {4936,},  -- Stonetalon Mountains
	[478] = {1191,},  -- Terokkar Forest
	[700] = {4873,5320,5481,},  -- Twilight Highlands
	[613] = {4869,5318,},  -- Vashj'ir
	[39]  = {4903,},  -- Westfall
	[40]  = {4898,},  -- Wetlands
	[857] = {6535,},  -- Krasarang Wilds
	[809] = {6537,},  -- Kun-Lai Summit
	[806] = {6300,},  -- The Jade Forest
}

local Horde = {
	[43]  = {4976,},  -- Ashenvale
	[181] = {4927,},  -- Azshara
	[486] = {1358,},  -- Borean Tundra
	[488] = {1359,},  -- Dragonblight
	[141] = {4978,},  -- Dustwallow Marsh
	[121] = {4979,},  -- Feralas
	[463] = {4908,},  -- Ghostlands
	[490] = {1357,},  -- Grizzly Hills
	[465] = {1271,},  -- Hellfire Peninsula
	[24]  = {4895,},  -- Hillsbrad Foothills
	[491] = {1356,},  -- Howling Fjord
	[477] = {1273,},  -- Nagrand
	[11]  = {4933,},  -- Northern Barrens
	[21]  = {4894,},  -- Silverpine Forest
	[607] = {4981,},  -- Southern Barrens
	[81]  = {4980,},  -- Stonetalon Mountains
	[478] = {1272,},  -- Terokkar Forest
	[700] = {5501,5482,5321,},  -- Twilight Highlands
	[613] = {4982,5319,},  -- Vashj'ir
	[857] = {6536,},  -- Krasarang Wilds
	[809] = {6538,},  -- Kun-Lai Summit
	[806] = {6534,},  -- The Jade Forest
}
	faction = UnitFactionGroup("player")
	if faction == "Alliance" then
	liste = Alliance[IdZone];
	elseif faction == "Horde" then
	liste = Horde[IdZone];
	end
	
	ListeNeutre = Neutral[IdZone];
	
	if liste ~= nil and ListeNeutre ~= nil then
	for i = 1, #liste do
	table.insert(ListeNeutre, liste[i])
	end
	elseif liste ~= nil then
	ListeNeutre = liste	
	end
	
	if ListeNeutre ~= nil then
	return ListeNeutre
	else
	return 0
	end
end

-- Fonction qui renvoie la catégorie HF en fonction de la zone (pour les HF pvp et Sombrelune)
function CategorieListe(IdZone)
-- Battleground
if IdZone == 461 then return 14802 end -- "Arathi Basin"
if IdZone == 401 then return 14801 end -- "Alterac Valley"
if IdZone == 482 then return 14803 end -- "Eye of the Storm"
if IdZone == 443 then return 14804 end -- "Warsong Gulch"
if IdZone == 512 then return 14881 end -- "Strand of the Ancients"
if IdZone == 501 then return 14901 end -- "Wintergrasp"
-- Cataclysm
if IdZone == 540 then return 15003 end -- "Isle of Conquest"
if IdZone == 736 then return 15073 end -- "Battle for Gilneas"
if IdZone == 626 then return 15074 end -- "Twin Peaks"
if IdZone == 708 then return 15075 end -- "Tol Barad"
-- Mop
if IdZone == 860 then return 15074 end -- "Mines Eclargent"
if IdZone == 865 or IdZone == 881 then return 15075 end -- "Temple de Kotmogu"

-- ARENA
if IdZone == -1 then return 165 end -- ARENA
-- Darkmoon Fair
if IdZone == 823 then return 15101 end
-- Bastonneurs
if IdZone == 922 or IdZOne == 925 then return 15202 end
--if IdZone == 823 then return 15101 end
return 0
end

-- Fonction qui liste les HF selon la zone (raids)
function RaidListe(IdZone)
-- CONSTRUCTION BASE DE DONNEES
local TableauHF = {
-- Wrath of the Lich King
["onyxia10"] = {4404,4402},
["onyxia25"] = {4407,4405},
["archavon10"] = {4016},
["archavon25"] = {4017},
["malygos10"] = {1874,2148},
["malygos25"] = {1875,2149},
["sartha10"] = {2049,2050,2051,624,2047},
["sartha25"] = {2052,2053,2054,1877,2048},
["naxx10"] = {1997,1858,1856,2178,2176,1996,2182,2146,2184,578},
["naxx25"] = {2140,1859,1857,2179,2177,2139,2183,2147,2185,579},
["ulduar10"] = {2907,2909,3056,2905,2911,2925,2927,2930,2923,2919,2933,3058,2937,2934,2931,2947,2945,2941,2940,2939,2951,2959,2953,2955,3006,3076,2961,3182,2963,2967,3176,2971,2977,2975,2973,2982,2980,3179,2989,3180,3138,3181,2996,3159,3015,3008,3012,3014,3003},
["ulduar25"] = {2908,2910,3057,2906,2912,2926,2928,2929,2924,2921,3059,2938,2936,2932,2948,2946,2944,2943,2942,2952,2960,2954,2956,3007,3077,2962,3184,2965,2968,3183,2972,2978,2976,2974,2983,2981,3187,3237,3189,2995,3188,2997,3164,3016,3010,3013,3017,3002},
["coliseum10"] = {3917,3797,3936,3996,3799,3800},
["coliseum25"] = {3916,3813,3937,3997,3815,3816},
["icc25"] = {4534,4535,4536,4537,4538,4577,4578,4582,4539,4579,4580,4581,4601},
["icc10"] = {4610,4611,4612,4613,4614,4615,4616,4617,4618,4619,4620,4622,4621},
-- Cataclysm
["bwd"] =  {5306,5309,5307,5310,5308,4849,4842},
["bot"] =  {4852,5312,5313,5311,4850},
["tfw"] =  {5304,5305,4851},
["firelands "] =  {5810,5813,5829,5821,5855,5799,5830,5802},
["ds"] =  {6174,6180,6128,6105,6133,6107,6175,6084},
-- Mists of Pandaria
["ms"] = {6455,7056,7485,6687,6823,6674,6686,},
["hof"] = {7486,6553,6937,6922,6683,6518,6936,},
["tes"] = {6824,6825,6717,6933,7487,},
["tot"] = {8094,8038,8073,8077,8082,8097,8098,8037,8081,8087,8086,8090,},
}
	
	-- Wrath of the Lich-King
	difficulty = GetInstanceDifficulty();
	if difficulty == 5 or difficulty == 7 then diff = 25 else diff = 10 end
	if IdZone == 718 and diff == 10 then Raid = "onyxia10"
	elseif IdZone == 718 and diff == 25 then Raid = "onyxia25"
	elseif IdZone == 532 and diff == 10 then Raid = "archavon10"
	elseif IdZone == 532 and diff == 25 then Raid = "archavon25"
	elseif IdZone == 527 and diff == 10 then Raid = "malygos10"
	elseif IdZone == 527 and diff == 25 then Raid = "malygos25"
	elseif IdZone == 531 and diff == 10 then Raid = "sartha10"
	elseif IdZone == 531 and diff == 25 then Raid = "sartha25"
	elseif IdZone == 535 and diff == 10 then Raid = "naxx10"
	elseif IdZone == 535 and diff == 25 then Raid = "naxx25"
	elseif IdZone == 529 and diff == 10 then Raid = "ulduar10"
	elseif IdZone == 529 and diff == 25 then Raid = "ulduar25"
	elseif IdZone == 543 and diff == 10 then Raid = "coliseum10"
	elseif IdZone == 543 and diff == 25 then Raid = "coliseum25"
	elseif IdZone == 604 and diff == 10 then Raid = "icc10"
	elseif IdZone == 604 and diff == 25 then Raid = "icc25"
	-- Cataclysm
	elseif IdZone == 754 then Raid = "bwd"
	elseif IdZone == 758 then Raid = "bot"
	elseif IdZone == 773 then Raid = "tfw"
	elseif IdZone == 800 then Raid = "firelands"
	elseif IdZone == 824 then Raid = "ds"
	-- Mists of Pandaria
	elseif IdZone == 896 then Raid = "ms"
	elseif IdZone == 800 then Raid = "hof"
	elseif IdZone == 824 then Raid = "tes"
	elseif IdZone == 930 then Raid = "tot"
	-- attente
	else Raid = IdZone
	end
		
	-- Retour des données
	if IdZone == 'table' then
	return TableauHF
	elseif type(Raid) == "string" and TableauHF[Raid] ~= nil and difficulty ~= 8 then
	return TableauHF[Raid]
	else
	return 0	
	end
end

-- Fonction qui liste les HF selon la zone (donjons)
function DonjonListe(IdZone)
local TableauHF = {
	-- LK
	[523] = {1919,}, -- Donjon d'Utgarde
	[520] = {2150,2036,2037,}, -- Le Nexus
	[533] = {1860,1296,1297,}, -- Azjol-Nérub
	[522] = {1862,2038,2056,}, -- Ahn’kahet : l’Ancien royaume
	[534] = {2151,2057,2039,}, -- Donjon de Drak’Tharon
	[536] = {2041,1865,2153,1816,}, -- Le fort Pourpre
	[530] = {2058,2152,2040,1864,}, -- Gundrak
	[526] = {2151,1866,2155,}, -- Ulduar: Les salles de Pierre
	[524] = {2043,2156,2157,1873,1790,}, -- Donjon d’Utgarde: Cime d’Utgarde
	[528] = {1871,1868,2046,2044,2045,}, -- L’Oculus
	[525] = {1834,2042,1867,}, -- Ulduar: Les salles de Foudre
	[542] = {3802,3804,3803,}, -- L’épreuve du champion
	[521] = {1872,1817,}, -- Grottes du Temps: L’Épuration de Stratholme
	[602] = {4525,4524,}, -- Citadelle de la Couronne de glace: Fosse de Saron
	[601] = {4522,4523,}, -- Citadelle de la Couronne de glace: La Forge des Âmes
	[603] = {4526,}, -- Citadelle de la Couronne de glace: Salles des Reflets
	-- CATACLYSM
	[753] = {5281,5282,5283,5284,}, -- Cavernes de Rochenoire
	[747] = {5290,5291,5292,}, -- Cité perdue des Tol’vir
	[757] = {5297,5298,}, -- Grim Batol
	[767] = {5285,5286,}, -- Trône des marées
	[820] = {5995,6130,}, -- La fin des temps
	[769] = {5288,5289,}, -- La cime du Vortex
	[768] = {5287,}, -- Le Cœur-de-Pierre
	[819] = {}, -- Heure du crépuscule
	[816] = {6127,6070,}, -- Puits d'éternite
	[759] = {5294,5295,5293,5296,}, -- Salles de l'Origine
	[781] = {5761,5750,5760,5858,}, -- Zul'Aman
	[793] = {5744,5743,5759,5762,}, -- Zul'Gurub
	-- PANDARIE
	[876] = {6420,6400,6089,6402,},  -- Brasserie Brune d'Orage
	[877] = {6477,6472,},  -- Monastère des Pandashan
	[20] = {6929,6946,6928,},  -- Monastère Ecarlate / cimetière (1)
	[874] = {6929,6946,6928,},  -- Monastère Ecarlate / cimetière (2)
	[885] = {6478,6736,6713,}, -- Palais Mogu’shan
	[875] = {6476,6479,6945,}, -- Porte du Soleil couchant
	[871] = {6427,6684,}, -- Salles Écarlates
	[898] = {6531,6394,6396,6821,}, -- Scholomance
	[887] = {6822,6688,6485,}, -- Temple Niuzao
	[867] = {6460,6475,6671,}, -- Un dague dans la nuit
	[] = {8106,}, -- Le trésor du roi tonnerre
} 

	difficulty = GetInstanceDifficulty();
	if TableauHF[IdZone] ~= nil and difficulty == 3 then
		if AutoTrackerAchievementDB["debug"] then print("Donjon load"); end
		return TableauHF[IdZone]
	else
	return 0
	end
end

-- Fonction qui liste les HF selon la zone (scenario)
function ScenarioListe(IdZone)
local TableauHF = {
	-- PANDARIE	
	[899] = {7273,7272}, -- Arene annihilation
	[900] = {7275,7276},  -- Crypte des Rois oubliés
	[884] = {6930,6931}, -- Festival de Brasse-Lune
	[906] = {7527,7526}, -- Marécage d'Âprefange A
	[851] = {7530,7529}, -- Marécage d'Âprefange H
	[880] = {7266,7267}, -- La forêt de Jade // Pierre verte
	[878] = {7261,7258,7257}, -- Une bière foudroyante
	[882] = {7231,7232,7239,7248}, -- Unga Ingou
	--
	[911] = {8011,8012}, -- Le territoire du Lion
	[913] = {8014,8015}, -- Halte de la Domination
	[912] = {7989,7990,7991,7992,7993}, -- Un peu de patience
	[914] = {7984,7986,7987}, -- Une dague dans la nuit
	--
	[883] = {8017,8016}, --Zan'vess
}
	difficulty = GetInstanceDifficulty();
	if TableauHF[IdZone] ~= nil and difficulty == 2 then
		if AutoTrackerAchievementDB["debug"] then print("Scenario load"); end
		return TableauHF[IdZone]
	else
	return 0
	end
end

-- ////////////////
-- Afficheurs
-- ////////////////

-- Print the incomplete achievements in specific category
function AchievListCat(IdCAT)
local currentlytracked = 0
local incomplete = false
	id = IdCAT
	for j = 1, GetCategoryNumAchievements(id) do
		aid, aname, points, completed, month, day, year, description, flags, icon, rewardText, isGuildAch = GetAchievementInfo(id,j)
		if not completed and currentlytracked < 10 then
			-- print (GetAchievementLink(aid));
			AddTrackedAchievement(aid);
			currentlytracked = currentlytracked +1
		end
	end
	return currentlytracked
end

-- Print the incomplete achievements in specific list and and them to the tracking list
function AchievListTable(Liste)
local currentlytracked = 0
local incomplete = false
local currentlycompleted = 0
	
	for i=1,#Liste do
		aid, aname, points, completed, month, day, year, description, flags, icon, rewardText, isGuildAch = GetAchievementInfo(Liste[i])
		if not completed and currentlytracked < 10 then
			-- print (GetAchievementLink(aid));
			AddTrackedAchievement(aid);
			currentlytracked = currentlytracked +1
		else
			currentlycompleted = currentlycompleted + 1
		end
	end
	if i == currentlycompleted then print(L["Zone clean"]); end
	return currentlytracked
end

-- Trouver le raid le plus rentable en HF
function CheckBestRaid()
	Tableau = RaidListe('table');
	TableauNB = {};
	
	for i in pairs(Tableau) do
	TableauNB[i] = 0
		for j,v in pairs(Tableau[i]) do
		aid, aname, points, completed, month, day, year, description, flags, icon, rewardText, isGuildAch = GetAchievementInfo(v)
		if not completed then TableauNB[i] = TableauNB[i] + 1 end
		end
	end
	
	for i,v in pairs(TableauNB) do
		if v ~= 0 then print(i,v) end
	end
end

-- ////////////////
-- Langue
-- ////////////////
function AtaLocalisation(lang)
L = {};
	debut_ligne = "|cFFFF0000> "
	if lang == "frFR" then
		L["Pas de liste de ce nom"] = "Pas de liste de ce nom";
		L["Création de la sauvegarde"] = "Création de la sauvegarde";
		L["Mise à jour"] = "Mise à jour";
		L["Nom de sauvegarde invalide"] = "Nom de sauvegarde invalide";
		L["Liste sauvegardée"] = "Liste sauvegardée";
		L["Zone sans Haut-faits"] = "Zone sans Haut-faits";
		L["Commande non reconnue"] = "Commande non reconnue";
		L["Zone clean"] = "Félicitation, il n'y a plus de HF à faire dans cette zone.";
		--
		L["ata config"] = debut_ligne .. "|cFF00FF00/ata config |r affiche l'interface des otpions";
		L["ata check"] = debut_ligne .. "|cFF00FF00/ata check |r affiche le nombre de HF à faire restant dans chaque raid";
		L["ata clean"] = debut_ligne .. "|cFF00FF00/ata clean |r vide le suivi des HF";
		L["ata save"] = debut_ligne .. "|cFF00FF00/ata save <nom> |r enregistre la liste des HF en suivi sous le nom choisi";
		L["ata load"] = debut_ligne .. "|cFF00FF00/ata load <nom> |r affiche les HF enregistrés dans la liste <nom>";
		L["ata defaut"] = debut_ligne .. "|cFF00FF00/ata defaut <nom> |r affiche les HF enregistrés dans la liste <nom> s'il n'y a rien d'autre à afficher";
		-- Raids
		L["ata raid lk"] = debut_ligne .. "|cFF00FF00/ata {onyxia/archavon/malygos/sartha/naxx/ulduar/coliseum/icc}{10/25}";
		L["ata raid cata"] = debut_ligne .. "|cFF00FF00/ata {bwd,bot,tfw,firelands,ds}";
		
		-- UI
		Text1:SetText("Arène")
		Text2:SetText("Raids")
		Text3:SetText("Régions")
		Text4:SetText("Donjons et Scénarios")
		Text5:SetText("sinon")
	else -- lang == "enEN"
		L["Pas de liste de ce nom"] = "No tracklist with this name";
		L["Création de la sauvegarde"] = "Generating variables";
		L["Mise à jour"] = "Updating options";
		L["Nom de sauvegarde invalide"] = "Save name error";
		L["Liste sauvegardée"] = "Tracklist recording";
		L["Zone sans Haut-faits"] = "Area without achievement";
		L["Commande non reconnue"] = "Unknwown command";
		L["Zone clean"] = "Congratulation, there is more to achievements in this area.";
		--
		L["ata check"] = "Use '/ata check' to known the raid with less complete achievements.";
		-- UI
		Text1:SetText("Arena")
		Text2:SetText("Raids")
		Text3:SetText("Zones")
		Text4:SetText("Dungeons and Scenarios")
		Text5:SetText("else")
	end
	defautval:SetText(AutoTrackerAchievementDB["defautliste"])
	version:SetText("Version " .. AutoTrackerAchievementDB["version"])
end